import java.lang.Object.*;
import java.util.*;
import java.io.*;

public class  MXBtokenizer {
	TokenList tklist = new TokenList();
	public MXBtokenizer() {}
	public TokenList Tokenize (String Command) {
		int flag = 0;
		String word = new String();    // next string token from the character stream
		String nword = new String();   // uppercase version of "word"
		
		StringTokenizer tok = new StringTokenizer(Command, ":/[]><= )\"\t\n\r\f", true);   // character stream
		flag = 0;
		while (tok.hasMoreTokens()) {
			Token tkn = new Token();    // Our token
			
			if (flag == 0) {
			word = tok.nextToken();     // get next string token from the list.
			}
			else if (flag == 5) { flag = 0;}  // if flag is 5, it means "word" already has a value from previous iteration

			//  Recognize "::" 
			if (word.equals(":")) {
				String lookUp  = tok.nextToken();
				word = word + lookUp;
                if (word.equals("::")) {
				  tkn.SetValue(word);
				  tkn.SetType("Separator");

				  tklist.InsertToken(tkn);         // insert "::" token into the list.
                }
				continue;
			}
			
			// Recognize other separators
			
			if (word.equals("[") || word.equals("]") || word.equals("/")|| word.equals(")")) {
				tkn.SetType("Separator");
				tkn.SetValue(word);
				
				tklist.InsertToken(tkn);
				continue;
			}
			
			// Recognize keywords
			nword = word.toUpperCase();
			if (nword.equals("CREATE") || nword.equals("INSERT") || 
			    nword.equals("DROP") || nword.equals("LIST")|| 
			    nword.equals("STATS")|| nword.equals("XML") || 
			    nword.equals("FILE")|| nword.equals("CLEAR") || 
			    nword.equals("DELETE") || nword.equals("RETURN")) 
			{
				tkn.SetType("Keyword");
				tkn.SetValue(word);
				
				tklist.InsertToken(tkn);
				continue;
			}
			
			// Recognize Xpath (XPLite) Axes
			if (nword.equals("SELF") || nword.equals("CHILD") || 
			    nword.equals("PARENT") || nword.equals("FOLLOWING-SIBLING") || 
			    nword.equals("PRECEDING-SIBLING")  || nword.equals("ATTRIBUTE")|| 
			    nword.equals("PRECEDING") || nword.equals("FOLLOWING") || 
				nword.equals("ANCESTOR") || nword.equals("DESCENDANT")) 
			{
				tkn.SetType("Axis");
				tkn.SetValue(word);
				
				tklist.InsertToken(tkn);
                continue;
			}
			
			// Recognize functions. 
			
	        int len = word.length();
			if (word.contains("(")) {
				if ((word.substring(len-1, len)).equals("(")) {    // this is the case when the token ends with "("
                    tkn.SetValue(word);                            // We insert just one token
					tkn.SetType("Function");
                  
                    tklist.InsertToken(tkn);
           
				}
				else {                                             // "(" is in the middle of the string token
					String[] tmp = new String[2];                  // we need to split it into two tokens, insert the first, and 
					tmp = word.split("[(]");                       // continue recognizing the second.
					tkn.SetValue(tmp[0]+"(");
					tkn.SetType("Function");
					tklist.InsertToken(tkn);
					
					word = tmp[1];
					flag = 5;                                    // set the flag to indicate that we do not need to read next token
					//Token tkn2 = new Token();
					//tkn2.SetValue(tmp[1]);
					//tkn2.SetType("Other");
					//tklist.InsertToken(tkn2);
				}
				continue;
				}
			
			// Recognize "=" operator
			
			if(word.equals("=")) {
				tkn.SetType("Operator");
				tkn.SetValue("word");
				tklist.InsertToken(tkn);
				continue;
			}
			
			// Recognize strings in double quotes
			
			if(word.equals("\"")) {
				nword = tok.nextToken();
				while(!nword.equals("\"")){
					word = word + nword;
					nword = tok.nextToken();
				}
				word = word + "\"";
				tkn.SetType("Other");
				tkn.SetValue(word);
				tklist.InsertToken(tkn);
				continue;
			}
			
			// Recognize all other operators
			
			if (word.equals("<") || word.equals(">")) {   // this is approximate. It will recognize "<<" and ">>" are proper
				String lookUp  = tok.nextToken();
				if (lookUp.equals(">") || lookUp.equals("=") || lookUp.equals("<")) {   // if next token is "=", "<", ">" 
					word = word + lookUp;                                               // we get a compound operator
					tkn.SetType("Operator"); 
					tkn.SetValue(word);
					tklist.InsertToken(tkn);
					continue;
				}
				else {                               // if next token is not ">", "<" or "=", then our operator is ">" or "<" and
					tkn.SetValue(word);              // we need to recognize token lookUp on the next iteration
					tkn.SetType("Operator");
					tklist.InsertToken(tkn);
                    word = lookUp;
					flag = 5;
					continue;
				}
			}
			
			// Recognize "other" tokens that are not strings in double quotes
			tkn.SetType("Other");
			tkn.SetValue(word);
			tklist.InsertToken(tkn);
		}
		return tklist;
//		for(Iterator i = tklist.value.iterator(); i.hasNext();)
//			System.out.println(i.next());
//		System.out.println();
//		for(Iterator i = tklist.type.iterator(); i.hasNext();)
//			System.out.println(i.next());
	}
}

